<?php

/*
Author:http://www.creotec.com
Using: https://github.com/abraham/twitteroauth
Notes: Use as is.  Add security, error checking etc before moving to a production environment
Please NOTE: No support is available for this script!
*/

require_once("config.php");
header("Content-Type: application/xml; charset=UTF-8");

session_start();

$twitteruser = $_REQUEST['u'];

if (strlen($twitteruser)>3) {
	$cachefile = CACHEPATH.$twitteruser."-tweets.xml";
	$cachetime = (60 * 60)*2; //Time in seconds to check cached file
	$mycache = "yes";
	if (file_exists($cachefile) AND (time() - $cachetime) < filemtime($cachefile)) {
		include($cachefile);
		exit;
	}
	ob_start();
}

require_once("twitteroauth/twitteroauth.php");

function getConnectionWithAccessToken($cons_key, $cons_secret, $oauth_token, $oauth_token_secret) {
	$connection = new TwitterOAuth($cons_key, $cons_secret, $oauth_token, $oauth_token_secret);
	return $connection;
}

function twitterJSON($twitteruser,$lines=10) {
	if ($twitteruser) {
		$connection = getConnectionWithAccessToken(CONSUMERKEY,CONSUMERSECRET,ACCESSTOKEN,ACCESSTOKENSECRET);
		$tweets = $connection->get("https://api.twitter.com/1.1/statuses/user_timeline.json?screen_name=".$twitteruser."&count=".$lines);
		return json_encode($tweets);
	}
}

$list_name = $twitteruser." on Twitter";
$fetch_json = twitterJSON($twitteruser,$_REQUEST['l']);
$return = json_decode($fetch_json);
$now = date("D, d M Y H:i:s T");
$link = htmlspecialchars('http://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'].'?'.$_SERVER['QUERY_STRING']);

?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
	<channel>
		<title><?php echo $list_name; ?></title>
		<link><?php echo $link; ?></link>
		<atom:link href="<?php echo $link; ?>" rel="self" type="application/rss+xml" />
		<description><?php echo $list_name; ?></description>
		<pubDate><?php echo $now; ?></pubDate>
		<lastBuildDate><?php echo $now; ?></lastBuildDate>
	<?php foreach ($return as $line){ ?>
	<item>
		<title><?php echo htmlspecialchars(htmlspecialchars_decode($line->user->screen_name.": ".strip_tags($line->text))); ?></title>
		<description><?php echo htmlspecialchars(htmlspecialchars_decode(strip_tags($line->text))); ?></description>
		<guid><?php echo htmlspecialchars("https://twitter.com/".$line->user->screen_name."/statuses/".$line->id_str); ?></guid>
		<link><?php echo htmlspecialchars("https://twitter.com/".$line->user->screen_name."/statuses/".$line->id_str); ?></link>
	</item>
	<?php } ?>
</channel>
</rss>

<?php

if ($mycache == "yes" AND $cachefile) {
	$fp = fopen($cachefile, 'w');
	fwrite($fp, ob_get_contents());
	fclose($fp);
	ob_end_flush();
}

?>